@rem Copyright IBM Corp. 1999,2000

@setlocal
@echo off

rem Setup standard environment variables.

call ..\setupCmdLine.bat


rem Test JAVA_HOME and java:
rem
rem Sanity check to keep us from getting into
rem an infinite loop.  (Caused by the 'if errorlevel 1'
rem statement, below.)

rem Test #1: JAVA_HOME must be set by 'setupCmdLine.bat',
rem at the beginning of this file (or elsewhere).

:TEST_JHOME

if (%JAVA_HOME%) == () goto NO_JHOME
goto SET_CP

:NO_JHOME
echo ERROR: Environment variable JAVA_HOME was not set; aborting.
goto DONE

:SET_CP

set WAS_CP=%WAS_HOME%\lib\ibmwebas.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\properties
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\servlet.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\webtlsrn.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\lotusxsl.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\compat.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\xalan.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\ns.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\ejs.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\ujc.jar
set WAS_CP=%WAS_CP%;%DB2DRIVER%
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\repository.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\admin.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\console.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\was20cm.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\tasks.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\xml4j.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\vaprt.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\sslight.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\ibmjndi.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\deployTool.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\databeans.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\classes
set WAS_CP=%WAS_CP%;%JAVA_HOME%\lib\tools.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\bsf.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\dertrjrt.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\derdbpw.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\ivjejb35.jar
set WAS_CP=%WAS_CP%;%WAS_HOME%\lib\js.jar

set CLASSPATH=%WAS_CP%
set PATH=%WAS_HOME%\bin;%PATH%


rem Finally, launch the admin server:
rem
rem Exit code 174 means that the configuration information is
rem inconsistent.
rem
rem Exit code 87 means that an immediate restart is requested.
rem
rem '-nodeRestart' is used to indicate a node restart.
rem

:START_S

set restart=-nodeRestart

:RESTART_S

%JAVA_HOME%\bin\java -DDER_DRIVER_PATH=%DER_DRIVER_PATH% -Xmx128m -Xminf0.15 -Xmaxf0.25 -Djavax.rmi.CORBA.UtilClass=com.ibm.CORBA.iiop.Util -Dcom.ibm.CORBA.iiop.noLocalCopies=true com.ibm.ejs.sm.server.AdminServer -bootFile %WAS_HOME%\bin\admin.config %restart% %1 %2 %3 %4

if errorlevel 174 goto DONE
set restart=
if errorlevel 87 set restart=-nodeRestart
if errorlevel 1 goto RESTART_S
if errorlevel 0 goto DONE


@rem Closeout the changes from the top of file.
@rem The 'endlocal' bounds the 'set echo off' setting.

:DONE
@endlocal
