/*
* @(#)src/demo/rmi-iiop/hello/RemoteHelloServer.java, ds122, ds122, 20000107 1.1.1.3
* ===========================================================================
* Licensed Materials - Property of IBM
* IBM Java(tm)2 SDK, Standard Edition, v 1.2
*
* (C) Copyright IBM Corp. 1999 All Rights Reserved.
* Copyright 1998 1999 by Sun Microsystems Inc.,
* ===========================================================================
*/

package hello;

import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import java.util.Properties;
import javax.naming.InitialContext;
import java.rmi.RMISecurityManager;

public class RemoteHelloServer extends PortableRemoteObject
    implements RemoteHello
{
    public RemoteHelloServer () throws RemoteException
    {
    }

    public String message ()
    {
	System.out.println ("got request");
	return "Hello World!";
    }

    public static void main (String[] args)
    {
	try
	    {
		if ( System.getSecurityManager() == null ) {
		    System.setSecurityManager (new RMISecurityManager());
		}

		RemoteHelloServer obj = new RemoteHelloServer ();

		// Pass system properties with -D option of java command, e.g.
		// for jrmp ...
		// -Djava.naming.factory.initial=com.sun.jndi.registry.RegistryContextFactory
		// for iiop ...
		// -Djava.naming.factory.initial=com.sun.jndi.cosnaming.CNCtxFactory

		InitialContext context = new InitialContext ();
		context.rebind ("RemoteHelloServer", obj);
		System.out.println ("HelloServer bound in registry");
	    }
	catch (Exception e)
	    {
		System.out.println ("HelloServer Exception: " + e.getMessage());
		e.printStackTrace ();
	    }
    }

}
