/*
* @(#)src/demo/rmi-iiop/idl/RemoteHelloServer.java, ds122, ds122, 20000107 1.1.1.3
* ===========================================================================
* Licensed Materials - Property of IBM
* IBM Java(tm)2 SDK, Standard Edition, v 1.2
*
* (C) Copyright IBM Corp. 1999 All Rights Reserved.
* Copyright 1998 1999 by Sun Microsystems Inc.,
* ===========================================================================
*/

package hello;

// RemoteHelloServer will use the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

public class RemoteHelloServer 
{
    public static void main(String args[])
    {
	try{
    
	    // Create and initialize the ORB
	    ORB orb = ORB.init(args, null);
      
	    // Create the servant and register it with the ORB
	    HelloServant helloRef = new HelloServant();
	    orb.connect(helloRef);
      
	    // Get the root naming context
	    org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
	    NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
	    // Bind the object reference in naming
	    NameComponent nc = new NameComponent("RemoteHelloServer", "");
	    NameComponent path[] = {nc};
	    ncRef.rebind(path, helloRef);
      
	    // Wait for invocations from clients
	    System.out.println("IDL Hello Server waiting for client invocations");
	    java.lang.Object sync = new java.lang.Object();
	    synchronized(sync){
		sync.wait();
	    }
      
	} catch(Exception e) {
	    System.err.println("ERROR: " + e);
	    e.printStackTrace(System.out);
	}  
    }
}

class HelloServant extends _RemoteHelloImplBase
{
    public String message()
    {
	System.out.println("returning Hello World from IDL server");
	return "Hello world from IDL Server!!";
  
    }
}
