// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - FeedbackServlet
*/ 
package WebSphereSamples.Feedback;
// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.Feedback.FeedbackUpdateBean;
import WebSphereSamples.Feedback.FeedbackQueryBean;

public class FeedbackServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{
   /*****************************************************************************
   * Process incoming requests for information
   * 
   * @param request Object that encapsulates the request to the servlet
   * @param response Object that encapsulates the response from the servlet
   */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {
         // Instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.Feedback.FeedbackUpdateBean feedbackUpdate = null;
         feedbackUpdate = (WebSphereSamples.Feedback.FeedbackUpdateBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.Feedback.FeedbackUpdateBean");

         setRequestAttribute("feedbackUpdate", feedbackUpdate, request);

         // Initialize the bean URL property from the webapp URL attribute
         feedbackUpdate.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         feedbackUpdate.setDriver(getParameter(request, "driver", true, true, false, null));

         // Initialize the bean name property from the parameters
         feedbackUpdate.setName(getParameter(request, "name", true, true, true, null));

         // Initialize the bean email property from the parameters
         feedbackUpdate.setEmail(getParameter(request, "email", true, true, true, null));

         // Initialize the bean subject property from the parameters
         feedbackUpdate.setSubject(getParameter(request, "subject", true, true, true, null));

         // Initialize the bean comment property from the parameters
         feedbackUpdate.setComment(getParameter(request, "comment", true, true, true, null));

         // Call the execute action on the bean.
         feedbackUpdate.execute();

         // Instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.Feedback.FeedbackQueryBean feedbackQuery = null;
         feedbackQuery = (WebSphereSamples.Feedback.FeedbackQueryBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.Feedback.FeedbackQueryBean");

         setRequestAttribute("feedbackQuery", feedbackQuery, request);

         // Initialize the bean URL property from the webapp URL attribute
         feedbackQuery.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         feedbackQuery.setDriver(getParameter(request, "driver", true, true, false, null));

         // Call the execute action on the bean.
         feedbackQuery.execute();

         // Call the output page. If the output page is not passed
         // as part of the URL, the default page is called.
         callPage(getPageNameFromRequest(request), request, response);

      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}
