// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* 
* Description - ExpiringHTMLServlet
*/
package WebSphereSamples.YourCo.ExpHTMLServlet;

/**
* This sample demonstrates the use of expiring HTML (JSP) pages.
*/

public class ExpiringHTMLServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements java.io.Serializable
{
  /*****************************************************************************
  * Process incoming requests for information
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
  public void performTask(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
  {
    try 
    {
      // Get the current time
      java.util.Calendar currentTime = java.util.Calendar.getInstance();
      
      // The expiration time is noon each day
      if (currentTime.get(java.util.Calendar.HOUR_OF_DAY) < 12)
      {
        // Call the output page from the parameter.
        callPageNamed(getParameter(request, "beforeDatePage", true, true, false, "beforeDatePage"), request, response);
      }
      else 
      {
        //  Call the output page from the parameter.
        callPageNamed(getParameter(request, "afterDatePage", true, true, false, "afterDatePage"), request, response);
      }

    }
    catch (Exception theException)
    {
      handleError(request, response, theException);
    }
  }
}
