// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* 
* Description - Login
*/ 
package WebSphereSamples.YourCo.Login;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.YourCo.Login.LoginDBBean;
public class Login extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{

/*  ****************************************************************************
  * Process incoming requests for information
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {
         HttpSession session = request.getSession(true);

         // instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.YourCo.Login.LoginDBBean loginDBBean = null;
         loginDBBean = (WebSphereSamples.YourCo.Login.LoginDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Login.LoginDBBean");

         WebSphereSamples.YourCo.Login.SessionBean sessionBean = null;
         sessionBean = (WebSphereSamples.YourCo.Login.SessionBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Login.SessionBean");

         // Initialize the bean passwd property from the parameters
         loginDBBean.setPassword(getParameter(request, "passwd", true, true, false, null));

         // Initialize the bean URL property from the parameters
         loginDBBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         loginDBBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Initialize the bean username property from the parameters
         loginDBBean.setUsername(getParameter(request, "username", true, true, true, null));

         // Call the execute action on the bean.
         loginDBBean.execute();

         try
         {
            loginDBBean.getUSER_EMPNO(0);
            sessionBean.setEmpno( loginDBBean.getUSER_EMPNO(0) );
            sessionBean.setFirstName( loginDBBean.getEMPLOYEE_FIRSTNME(0) );
            sessionBean.setLastName( loginDBBean.getEMPLOYEE_LASTNAME(0) );
            sessionBean.setQuote( (loginDBBean.getUSER_QUOTE(0)).intValue() );
            sessionBean.setStock( (loginDBBean.getUSER_STOCK(0)).intValue() );
            sessionBean.setManager( (loginDBBean.getUSER_MANAGER(0)).intValue() );
            session.putValue("sessionBean", sessionBean);
            //       Call the output page. If the output page is not passed
            //       as part of the URL, the default page is called.
            callPage(getPageNameFromRequest(request), request, response);
         }
         catch (ArrayIndexOutOfBoundsException e)
         {
            callPage("NoData", request, response);
         }
      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}
