// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* This file was generated by IBM WebSphere Studio Version 3.0.2
* D:\WebSphere\Studio\BIN\GenerationStyleSheets\AppServerV3\JSP1.0\WebSphere\DatabaseBean.xsl stylesheet was used to generate this file.
*
* Description - CreateDatabaseBean
*/
package WebSphereSamples.Database;
// Imports

import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;


// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import javax.naming.*;
import com.ibm.ejs.ns.jndi.*;
import java.sql.*;
import java.util.*;


/**
* This bean creates and populates the database.
*/


public class CreateDatabaseBean extends java.lang.Object
{
   // Database ID constants
   static final int DB_DB2 = 0;
   static final int DB_ORACLE = 1;
   static final int DB_SYBASE = 2;
   static final int DB_SQLSERVER = 3;
   static final int DB_UNKNOWN = 999;

/*   *
   * Instance variable for password property
   */
   protected java.lang.String password = null;

/*   *
   * Instance variable for userID property
   */
   protected java.lang.String userID = null;

/*   *
   * Variable for the SelectResult - the SQL result set
   */
   protected SelectResult result;

/*   *
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

/*   *
   * Variable to hold connection
   */
   protected Connection connection = null;

/*   *
   * Variable to hold the data source name
   */
   protected String dataSourceName = "";

/*   *
   * Variable to hold the sample question
   */
   protected String question = "";

/*   *
   * Variable to hold an error string
   */
   protected String error = "";

/*   *
   * Variable to hold databaseName string
   */
   protected String databaseName = "";

/*   ****************************************************************************
   * Set method for the password property
   * @param value the new value for the password property
   */
   public void setPassword(java.lang.String value)
   {
      this.password = value;
   }

/*   ****************************************************************************
   * Get method for the userID property
   * @return the value of the userID property
   */
   public java.lang.String getUserID()
   {
      return userID;
   }

/*   ****************************************************************************
   * Set method for the userID property
   * @param value the new value for the userID property
   */
   public void setUserID(java.lang.String value)
   {
      this.userID = value;
   }

/*   ****************************************************************************
   * Get method for the userID property
   * @return the value of the userID property
   */
   public java.lang.String getDatabaseName()
   {
      return databaseName;
   }

/*   ****************************************************************************
   * Set method for the userID property
   * @param value the new value for the userID property
   */
   public void setDatabaseName(java.lang.String value)
   {
      this.databaseName = value;
   }


/*   ****************************************************************************
   * Get method for the App Server V3 dataSourceName property
   */
   public String getDataSourceName()
   {
      return dataSourceName;
   }

/*   ****************************************************************************
   * Set method for the App Server V3 dataSourceName property
   */
   public void setDataSourceName(String value)
   {
      this.dataSourceName = value;
   }

/*   ****************************************************************************
   * Set method for the question property
   *
   * @param value the new value for the property
   */
   public void setQuestion(String value)
   {
      this.question = value;
   }

/*   ****************************************************************************
   * Get method for the error property
   *
   * @param value the new value for the property
   */
   public String getError()
   {
      return this.error;
   }

/*   ****************************************************************************
   * Do the real work here
   *
   */
   public void createDatabase() throws SQLException, Exception, com.ibm.db.DataException
   {
      Vector tables = new Vector();
      String tableFile = databaseName + "tables.txt";
      int dbID = DB_UNKNOWN;
      String table = null;
      String create = null;
      String drop = null;

      InputStream is = null;
      InputStreamReader isr = null;
      BufferedReader br = null;
      String line = null;

               
      if ((is = this.getClass().getResourceAsStream( tableFile )) == null)
          throw new Exception("CreateDatabaseBean:  Can't find file '" + tableFile + "'");

      if ((isr = new InputStreamReader( is )) == null)
          throw new Exception("CreateDatabaseBean:  Can't get InputStreamReader for file '" + tableFile + "'");

      if ((br = new BufferedReader( isr )) == null)
          throw new Exception("CreateDatabaseBean:  Can't get BufferedReader for file '" + tableFile + "'");
      
      // Set database ID based on databaseName
      dbID = getDBIDFromName();

      if (dbID == DB_UNKNOWN)
      {
         error = "The Database Specified Is Invalid: " + this.getDatabaseName();
         throw new Exception("CreateDatabaseBean:  Unknown Database Name: " + this.getDatabaseName());
      }

      while ((line = br.readLine()) != null)
      {
         //
         // Note:  tokenizer will throw a NoSuchElementException if
         // there are blank lines at the end of the file tableFile.
         //

         StringTokenizer tokenizer = new StringTokenizer(line, "=");

         try
         {
            table = tokenizer.nextToken();
            create = tokenizer.nextToken();
         }
         catch (NoSuchElementException e)
         {
            System.out.println("Exception occurred during database setup:  " + e.getMessage());
            error = "<STRONG>There was an error parsing the file '" + tableFile + "'</STRONG>.\n" +
                    "The last line read was:  '" + line + "'.\n" +
                    "There may be a newline at the end of the file\n" +
                    "or the syntax is invalid.";
            throw new Exception("CreateDatabaseBean: Error parsing file " + tableFile);
         }

         drop = "drop table " + table;

         executeStatement( drop, true);
         executeStatement( create, true);

         tables.addElement(table);
      }

      br.close();

      for (Enumeration e = tables.elements(); e.hasMoreElements(); table = (String)e.nextElement())
      {
         is = this.getClass().getResourceAsStream( table + ".txt" );
         if (is != null)
         {
            String sql;
            isr = new InputStreamReader( is );
            br = new BufferedReader( isr );

            while ((line = br.readLine()) != null)
            {
               StringTokenizer tokenizer = new StringTokenizer(line, ";");

               sql = "insert into " + table + " values (" + tokenizer.nextToken();

               while (tokenizer.hasMoreTokens())
               {
                  sql += ", " + tokenizer.nextToken();
               }
               sql += ")";
               executeStatement( sql, true);
            }
            br.close();
         }
      }

      executeStatement("insert into POLL values (1, 0, 0, '" + this.question + "')", true);
   }

   /*****************************************************************************
   * Utility method to set databaseID based on databaseName attribute
   */
   private int getDBIDFromName()
   {
      String dbName = this.getDatabaseName();

      // use statements like "db2".equals(dbName) to eliminate
      // possible null pointer exceptions from dbName.equals("db2")

      if ("db2".equals(dbName))
      {return DB_DB2;}
      if ("oracle".equals(dbName))
      {return DB_ORACLE;}
      if ("sybase".equals(dbName))
      {return DB_SYBASE;}
      if ("sqlserver".equals(dbName))
      {return DB_SQLSERVER;}

      return DB_UNKNOWN;
   }

/*   ****************************************************************************
   * Utility method for createDatabase()
   *
   */
   protected void executeStatement(String stmt, boolean throwException)
   throws SQLException, com.ibm.db.DataException, Exception
   {
      Connection con = null;
      try
      {
         connection = getPooledConnection(userID, password);
         java.sql.Statement s = connection.createStatement();
         connection.commit();
         s.executeUpdate(stmt);
         connection.commit();
         s.close();
      }
      catch (SQLException e)
      {
         if (connection != null)
         {
            try
            {
               connection.close();
            }
            catch (Exception e2)
            {
               System.out.println (e2.getMessage());
            }
            connection = null;
         }
         else
         {
            System.out.println("Exception occurred during database setup:  " + e.getMessage());

            error = "Could not get a database connection.\n" +
                    "<STRONG>The most likely cause is an incorrect userid or password.</STRONG>\n" +
                    "Note that userids and passwords are case sensitive.\n" +
                    "You must stop and restart the Default " +
                    "Server after modifications\nto JDBC or datasource parameters.\n\n" +
                    "*** SQLState  :" + e.getSQLState() + "\n" +
                    "*** Error Code:" + e.getErrorCode() + "\n" +
                    "*** Exception :" + e + "\n";

            if (throwException)
               throw e;
         }
      }
      catch (NamingException e)
      {
         System.out.println("Exception occurred during database setup:  " + e);

         error = "Could not get a database connection.\n" +
                 "</STRONG>The most likely cause is an invalid datasource.</STRONG>\n" +
                 "Check to make sure the datasource (" + getDataSourceName() +
                 ") is valid and points \nto an actual " + getDatabaseName() + " " +
                 "database.\nYou must stop and restart the Default " +
                 "Server after\nmodifications to JDBC or datasource parameters.\n\n" +
                 "*** Exception :" + e + "\n";

         if (throwException)
            throw e;
      }
      catch (Exception e)
      {
         System.out.println("Exception occurred during database setup:  " + e.getMessage());

         error = ("An exception occurred during database setup: ** " + e + " **\n" +
                  "Error message: ** " + e.getMessage() + " **\n\n" +
                  "</STRONG>Check that all of the database access parameters submitted are correct.</STRONG>\n" +
                  "(Note that the username and password are case sensitive.)");

         if (throwException)
            throw e;
      }
      finally
      {
         if (connection != null)
         {
            try
            {
               connection.close();
            }
            catch (Exception e2)
            {
               System.out.println (e2.getMessage());
            }
         }
      }// finally
   }

/*   ****************************************************************************
   * Close the result set and release resources
   */
   public void closeResultSet()
   {
//       Release the SQL statement resources
      try
      {
         if (result != null)
         {
            result.close();
            result = null;
         }
      }
      catch (Exception e)
      {
         System.out.println("Error occurred in com.ibm.db.SelectResult.close");
         e.printStackTrace();
      }
      try
      {
//          Close the App Server V3 connection
         if (connection != null)
         {
            connection.close();
            connection = null;
         }
      }
      catch (Exception e)
      {
         System.out.println("Error occurred in java.sql.Connection.close");
         e.printStackTrace();
      }
      return ;
   }



/*   ****************************************************************************
   * Release resources we might be holding when garbage collection occurs.
   */
   protected void finalize() throws Throwable
   {
      closeResultSet();
   }

/*   ****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param driver Contains the JDBC driver name to use for the connection
   * @param URL Contains the database url for the connection
   * @param userID Contains the userID to use for the database connection
   * @param password Contains the password to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String userID, String password)
   throws SQLException, NamingException
   {
//      Connection conn = null;

//      try
//      {
//          create parameter list to access naming system
      Hashtable parms = new Hashtable();
      parms.put(Context.INITIAL_CONTEXT_FACTORY, CNInitialContextFactory.class.getName());
//          access naming system
      Context context = new InitialContext(parms);
//          get DataSource factory object from naming system
      ds = (DataSource)context.lookup(getDataSourceName());
      return ds.getConnection(userID, password);
//      }
//      catch (Throwable t)
//      {
//         t.printStackTrace();
//      }
//      return conn;
   }
}

