<%-- this file tests the JSP directives, the SCRIPT tag,  and whether java can be split across multiple scriptlet instances --%>

<%@ page import="StackTrace,com.ibm.websphere.servlet.error.ServletErrorReport" %> 

<jsp:useBean id="ErrorReport" class="com.ibm.websphere.servlet.error.ServletErrorReport" scope="request" />

<html>
<head><title>Error <%= ErrorReport.getMessage() %></title></head>
<body>
<img src="/webapp/examples/banner.gif" alt="banner image"><p>

<H1>Error <%= ErrorReport.getErrorCode() %> </H1>
<H4>An error has occured while processing request: <%= HttpUtils.getRequestURL(request) %></H4>

<B>Message: </B><%= ErrorReport.getMessage() %><BR>
<B>StackTrace: </B><%= ErrorReport.getStackTrace() %> 
<H1> Stack Dump </H1>
<% Throwable th = ErrorReport.getRootCause();
if(th == null) th = ErrorReport;
StackTrace stackTrace = StackTrace.getStackTrace(th); %>
<Table>
<% for(int i=0; i<stackTrace.getStackDepth(); i++){ %>
<TR>
<TD><%= stackTrace.getStackLine(i).getFullClassName() %>.<%= stackTrace.getStackLine(i).getMethodName() %>()
<TD>
<%
     String sourceFile = stackTrace.getStackLine(i).getSourceFilename();
     if(sourceFile == null){//caused by JIT
       out.println("Unknown Source");
       continue;
     }
     //calculate the filename from the package and the sourceFile
     String pkg = stackTrace.getStackLine(i).getPackage();
     if(pkg != null) pkg = "/" + pkg.replace('.', '/');
     else pkg = "";
     String sourcePath = pkg + "/" + sourceFile;
     int lineNumber = stackTrace.getStackLine(i).getSourceFileLineNumber();
%>
<A HREF=./SourceCodeViewer<%=sourcePath%>#line<%= lineNumber %>?highlight=<%= lineNumber %>><%= stackTrace.getStackLine(i).getSourceFilename() %>:<%= lineNumber %></A>

<% } %>

</Table>

</body>
</html>
